"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Carousel = Carousel;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _CarouselModule = _interopRequireDefault(require("./Carousel.module.css"));

var _CarouselItem = _interopRequireDefault(require("../carousel-item/CarouselItem"));

var _GreaterThan = _interopRequireDefault(require("../GreaterThan"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// TODO add Docs to *every* function

/**
 * 
 * @param {Object} param0 
 * @param {number} [param0.maxGapItems]
 * @param {number} [param0.minGapItems]
 * @param {number} [param0.paddingBodyContainer]
 * @param {number} [param0.swipeSensativity]
 * @param {string} [param0.title]
 * @param {import('react').CSSProperties} [param0.carouselStyle]
 * @param {import('react').CSSProperties} [param0.titleStyle]
 * @param {JSX.Element | readonly JSX.Element[]} param0.children
 * @returns 
 */
function Carousel(_ref) {
  let {
    maxGapItems,
    minGapItems,
    paddingBodyContainer,
    swipeSensativity,
    title,
    children,
    carouselStyle,
    titleStyle
  } = _ref;
  const bodyContainer = (0, _react.useRef)();
  const [childWidth, setChildWidth] = (0, _react.useState)(0);
  const [touchStart, setTouchStart] = (0, _react.useState)(null);
  const [touchEnd, setTouchEnd] = (0, _react.useState)(null);
  const [containerSize, setContainerSize] = (0, _react.useState)();
  const [itemTransalte, setItemTransalte] = (0, _react.useState)(0);
  const [carouselNeeded, setCarouselNeeded] = (0, _react.useState)(false);
  const [gapItems, setGapItems] = (0, _react.useState)(maxGapItems);
  const [itemsAmount, setItemsAmount] = (0, _react.useState)(0); // TODO add docs about the useEffect, what dose it calculate?

  (0, _react.useEffect)(() => {
    function handleResize() {
      const fullContainerSize = bodyContainer.current.clientWidth;
      setItemsAmount(Math.floor((fullContainerSize - paddingBodyContainer * 2 + minGapItems) / (childWidth + minGapItems)));
      setContainerSize(fullContainerSize - paddingBodyContainer * 2);
      setItemTransalte(0); // try to find solution!

      const fullCardsContainerLength = _react.default.Children.count(children) * childWidth + maxGapItems * (_react.default.Children.count(children) - 1);

      if (fullContainerSize > fullCardsContainerLength) {
        return setCarouselNeeded(false);
      }

      setCarouselNeeded(true);
    }

    window.addEventListener('resize', handleResize);
    handleResize();
    return () => {
      window.removeEventListener('resize', handleResize);
    };
  }, [bodyContainer, children, minGapItems, paddingBodyContainer, maxGapItems, childWidth]); // TODO add docs about the useEffect, what dose it calculate?

  (0, _react.useEffect)(() => {
    setGapItems((containerSize - itemsAmount * childWidth) / itemsAmount);
  }, [containerSize, itemsAmount, childWidth]);
  /**
   * save the location of the firt touch on the screen
   * @param {Event} e
   */

  function onTouchStart(e) {
    setTouchStart(e.targetTouches[0].clientX);
  }
  /**
   * update the location where the finger swipes
   * @param {Event} e 
   */


  function onTouchMove(e) {
    setTouchEnd(e.targetTouches[0].clientX);
  }
  /**
   *
   * @returns 
   */


  function onTouchEnd() {
    if (!touchStart || !touchEnd) {
      return setTouchEnd(null);
    }

    const distance = touchStart - touchEnd;
    const isLeftSwipe = distance > swipeSensativity;
    const isRightSwipe = distance < -swipeSensativity;

    if (isLeftSwipe || isRightSwipe) {
      isLeftSwipe ? slideToRight() : slideToLeft();
    }

    setTouchEnd(null);
  }
  /**
   * *************** what does it caculate\
   * slide the items to the right
   * @returns {number}
   */


  function slideToRight() {
    if (itemTransalte - containerSize < -(_react.default.Children.count(children) * childWidth + gapItems * (_react.default.Children.count(children) - 1))) {
      return setItemTransalte(0);
    }

    setItemTransalte(itemTransalte - containerSize);
  }
  /**
  * slide the items to the left
  * @returns {number}
  */


  function slideToLeft() {
    if (itemTransalte >= 0) {
      return setItemTransalte(-((Math.floor(_react.default.Children.count(children) / itemsAmount) - (_react.default.Children.count(children) % itemsAmount === 0 ? 1 : 0)) * containerSize));
    }

    setItemTransalte(itemTransalte + containerSize);
  }

  return /*#__PURE__*/_react.default.createElement("div", {
    className: _CarouselModule.default.container,
    style: carouselStyle
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: _CarouselModule.default.ContribiutersText,
    style: titleStyle
  }, title), /*#__PURE__*/_react.default.createElement("div", {
    className: _CarouselModule.default.bodyContainer,
    ref: bodyContainer,
    onTouchStart: onTouchStart,
    onTouchMove: onTouchMove,
    onTouchEnd: onTouchEnd,
    style: {
      padding: "".concat(carouselNeeded ? "0 ".concat(paddingBodyContainer, "px") : "0 0")
    }
  }, /*#__PURE__*/_react.default.createElement("button", {
    onClick: slideToLeft,
    hidden: !carouselNeeded,
    className: _CarouselModule.default.buttonSlideLeft
  }, /*#__PURE__*/_react.default.createElement(_GreaterThan.default, null)), /*#__PURE__*/_react.default.createElement("div", {
    className: _CarouselModule.default.ContributerCardContainer,
    style: {
      gap: "".concat(carouselNeeded ? gapItems : maxGapItems, "px")
    }
  }, _react.default.Children.map(children, child => {
    return /*#__PURE__*/_react.default.createElement(_CarouselItem.default, {
      onWidthUpdate: childWidth => setChildWidth(childWidth),
      style: {
        transform: "translatex(".concat(itemTransalte + (carouselNeeded && gapItems / 2), "px)"),
        transition: "all 0.3s ease"
      }
    }, child);
  })), /*#__PURE__*/_react.default.createElement("button", {
    onClick: slideToRight,
    hidden: !carouselNeeded,
    className: _CarouselModule.default.buttonSlideRight
  }, /*#__PURE__*/_react.default.createElement(_GreaterThan.default, null))));
}

Carousel.defaultProps = {
  maxGapItems: 24,
  minGapItems: 8,
  paddingBodyContainer: 60,
  swipeSensativity: 50
};